#pragma once
#ifndef CONTENTMANAGER_H_
#define CONTENTMANAGER_H_

#include "baseobject.h"

namespace EPOC
{
	class Application;
	class BaseObject;
	class ContentManager : public BaseObject
	{
	public:
		ContentManager(Application *pApplication);
		virtual ~ContentManager();

		virtual bool Initialize();
		virtual void Cleanup();
		virtual bool Update(float fTimeDelta);
		
		void AddUpdateObject(BaseObject* pObject);
		void RemoveUpdateObject(BaseObject* pObject);

		inline Application* GetApplication(){ return m_pApplication;}
		
	protected:
		std::list<BaseObject *> m_rUpdateContainer;
		Application *m_pApplication;
	
	}; // class ContentManager
}; // namespace EPOC

#endif